var {throttle} = require('../../miniprogram_npm/throttle-debounce/index.cjs.js')

Page({

  /**
   * 页面的初始数据
   */
  data: {
    iconUrl:"../../images/icon_success.png",
    payPriceYuan:"0.00",
    description:"支付成功",
    goHomeCountDown:"3秒后跳转到首页",
    payCountDownTimer:null,
    //type==> 0:支付结果 1:退款结果 默认为0
    type:0,
    //是否退款or支付成功
    isSuccess:false,
    isShowBackHome:false,
    failedReason:"",
    //是否需要倒计时
    isNeedCountDown:false,
    //金额显示
    isShowPrice:false,
    isShowFailedReason:true,
    reOpText:"重新支付",
    countDownConfig:5
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    options.type = parseInt(options.type)
    options.isSuccess = 'true'===options.isSuccess

    var payPriceYuan = options.payPriceYuan
    var description = options.description
    this.setData({
      payPriceYuan:payPriceYuan,
      description:description,
      failedReason:options.failedReason
    })
    if(options.isSuccess==false){
      this.setData({
        isNeedCountDown:false
      })
      if(options.type==1){
        //退款失败
        this.setData({
          isSuccess:false,
          isShowBackHome:true,
          iconUrl:"../../images/icon_fail.png",
          description:"退款失败",
          failedReason:options.failedReason,
          isShowFailedReason:true,
          reOpText:"重新退款",
          type:1
        })
      }else{
        //支付失败
        this.setData({
          isSuccess:false,
          isShowBackHome:true,
          iconUrl:"../../images/icon_fail.png",
          description:"支付失败",
          failedReason:options.failedReason,
          isShowFailedReason:true,
          reOpText:"重新支付",
          type:0,
          isShowBackHome:false,
          countDownConfig:30,
          isNeedCountDown:true
        })
      }
    }else{
      this.setData({
        isNeedCountDown:true
      })
      if(options.type==1){
        //退款成功
        this.setData({
          isSuccess:true,
          isShowBackHome:true,
          iconUrl:"../../images/icon_success.png",
          description:"退款成功",
          isShowFailedReason:false,
          isShowPrice:true,
          type:1
        })
      }else{
        //支付结果
        this.setData({
          isSuccess:true,
          isShowBackHome:true,
          iconUrl:"../../images/icon_success.png",
          description:"支付成功",
          isShowFailedReason:false,
          isShowPrice:true,
          type:0
        })
      }
    }
    
  },

  onShow:function(){
     //回到首页倒计时    
    if(this.data.isNeedCountDown==true){
      this.startPayCountDown(this.data.countDownConfig)
    }
  },

  /**
   * 3秒倒计时结束 弹出选择支付方式
   */
  startPayCountDown:function(countDownConfig){
    
    this.setData({goHomeCountDown:countDownConfig+"s后跳转到首页"})
    if (this.data.payCountDownTimer != null) {
      clearInterval(this.data.payCountDownTimer)
    }
  
    var countDown = countDownConfig;
    var that = this;
    var payCountDownTimer = setInterval(() => {
        if(countDown <= 0){
          that.backHome()
          clearInterval(payCountDownTimer)
        }else{
          --countDown
          that.setData({goHomeCountDown:countDown+"s后跳转到首页"})
        }
    }, 1000);
  },

  onReOpClicked:throttle(1000,function(){
    if(this.data.type==0){
      //重新支付
      wx.navigateBack()
    }else{
      wx.navigateTo({
        url: '/pages/refund/refund',
      })
    }
  }),

  /**
   * 回到首页
   */
  backHome:throttle(1000,function(){
    wx.redirectTo({
      url: '/pages/home/home',
    })
  })

})